<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getData"
      :show-add-button="true"
      :add-button-text="dictionaryRu.addButtonTitle"
      is-fixed-header
      @select="onSelectionChanged"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      size="md"
      :data-grid="$refs.dataGrid"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <requisite-popup
        :data-source="selectedData"
        @save="preparedSave"
        @delete="onDelete"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import moment         from 'moment';
import api            from '@/api';
import models         from '@/models';
import paging         from '@/mixins/paging';
import itemMixin      from '@/mixins/edit-item';

import ObModal        from 'common-components/src/obComponents/obModal';
import ObTable        from 'common-components/src/obComponents/obTable';
import SinglePane     from 'common-components/src/obComponents/obSinglePanels';
import RequisitePopup from './modal/index';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__sb_dictionaries__requisite_groups';

export default {
  name: 'RequisitesIndex',
  components: {
    RequisitePopup,
    ObModal,
    SinglePane,
    ObTable
  },
  mixins: [
    paging,
    itemMixin
  ],
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      selectedData: {},
      dataGridRefName: 'requisitesList',
      api: {
        source    : 'sbRequisites',
        method    : 'getRequisiteGroups',
        createItem: 'createRequisiteGroup',
        editItem  : 'editRequisiteGroup',
        viewItem  : 'getRequisiteGroup'
      }
    };
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'title'
        },
        {
          title: this.dictionaryRu.columns.entity,
          key: 'type',
          html: data => {
            return this.objectType[data.type];
          }
        },
        {
          title: this.dictionaryRu.columns.number,
          key: 'pos',
          html: data => {
            return String(data.pos);
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          key: 'is_active',
          html: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        },
        {
          title: this.dictionaryRu.columns.date,
          key: 'created_at',
          html: data => {
            return data.created_at
              ? moment(data.created_at).format('DD.MM.YYYY')
              : '';
          }
        }
      ];
    },
    objectType() {
      return {
        participant: this.dictionaryRu.objectType.participant,
        resource:    this.dictionaryRu.objectType.resource
      };
    }
  },
  methods: {
    async onSelectionChanged(data) {
      try {
        this.newStatus = false;
        const _data = await api[this.api.source][this.api.viewItem](
          data.uuid,
          'ru'
        );
        this.selectedData = _data;
        this.$refs.viewItem.open();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    preparedSave(payload) {
      this.onSave({
        formData: payload,
        model: models.requisiteModel
      });
    },
    async getData(params) {
      try {
        const res = await api.sbRequisites.getRequisiteGroups(params);
        if (!res || res.data.error) return res;

        return res.data;
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async onDelete() {
      const notificationId = `${new Date().getTime()}remove`;

      try {
        await api.sbRequisites.deleteRequisiteGroup(this.selectedData.uuid);
        this.$notification({
          type: 'system_notification_success',
          message: 'Удалено'
        });
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалено'
        });
      } finally {
        this.$notification({
          event: 'close',
          id: notificationId
        });
      }
    }
  }
};
</script>
